// Vendor.h

#import <swarmobject/SwarmObject.h>
#import <simtools.h>

@interface Vendor: SwarmObject {
 
 int number;                        // is the offerer's ID number
 int use_printf;                    // when 0 printf is not used; when 1, some; 2, all

 float minPrice, maxPrice, minStartPrice, maxStartPrice;
 float minOfferPrice, maxOfferPrice;
 int memory; // memory of the previous situation; it increases by 1 when it operates
             // decreases by 1 if not; it starts from 0
}

-setNumber: (int) aNumber andPrintf: (int) use_p; 
                           // it sets the vendor's number and the value of use_printf
                           // when 0 printf is not used; when 1, some; 2, all

-(int)reportNumber;        // it reports the vendor's number

-setMinPrice: (float) min MaxPrice: (float) max
              minStartPrice: (float) minS maxStartPrice: (float) maxS;
                                    // it sets the values
                                    // minPrice and maxPrice
                                    // range, absolute min. and max
                                    // of the offer and of the starting prices
                                    // within which
                                    // at each time, after the required
                                    // adjustments...

-chooseRange;
                                    // the price range for the next offer
                                    // is decided ...

-(float) makeAnOffer;
         // it will be a random price, uniformly distributed 
         // between minOfferPrice and maxOfferPrice
-setMemory; //it clears the memory
-updateMemory: (int) yn; // yn=1 when it operates; yn=0 if not

-(float) reportMinPrice; // it returns the min and max offer prices
-(float) reportMaxPrice; // that are in use at that moment. 

@end
