// Keeper.m
// by Pietro Terna on the basis of Shuffler.m

// it picks up the first id, does a pop of all the list and puts the 
// former first id in the last position

#import "Keeper.h"

@implementation Keeper

-keepFromList: list {
  
  long n, i;
  
  n = [list getCount];
  if (n<2) {printf(
            "Keeper cannot handle a list with a number of elements < 2\n");
            exit(0);}


  kept = [list atOffset: 0];

  for (i=0;i<n-1;i++)[list atOffset: i put: [list atOffset: i+1]];
  [list atOffset: n-1 put: kept];

  return kept;
}

@end
