// MeanPrice.m

#import "MeanPrice.h"

@implementation MeanPrice   // implementation of the methods and description  
                            // of their local variables

-setZero {                  // it sets values to 0
  globalMean = 0;
  globalNumber=0;
  transactionMean=0;
  transactionNumber=0;
  return self;
}

-usePrintf: (int) use_p {
  use_printf=use_p;   // when 0 printf is not used; when 1, some; 2, all
  return self;
}

-addToGlobalMean: (float) aPrice { // an addend of the global mean 
  globalMean += aPrice;
  globalNumber++;
  return self;
}

-addToTransactionMean: (float) aPrice { // an addend of the transaction
                                        //mean
  transactionMean += aPrice;
  transactionNumber++;
  return self;
}

-findGlobalMean {           // it computes (and prints) the global mean
  if (globalNumber > 0) globalMean /= globalNumber;

  if (use_printf>=1)
  printf("The mean of the %3d prices is %5.2f\n",globalNumber,globalMean);
  return self;
}

-findTransactionMean {      // it computes and (prints) the transaction mean
                                                      
  if (transactionNumber > 0) transactionMean /= transactionNumber;                         
                                                      
  if (use_printf>=1)
  printf("The mean of the %3d prices in transations is %5.2f\n",
                                     transactionNumber,transactionMean);
  return self;
}

-(float) getGlobalMean {     // it reports the mean value
  return globalMean;
}

-(float) getTransactionMean {// it reports the mean value
  return transactionMean;
}

@end

