// Vendor.m

#import "Vendor.h"

@implementation Vendor


-setNumber: (int) aNumber andPrintf: (int) use_p { 
                            // it sets the oferer's ID number
  number=aNumber;           // on the basis of the value from aNumber
                            // and use_printf:
  use_printf=use_p;         // when 0 printf is not used; when 1, some; 2, all
  return self;
}

-(int) reportNumber {       // it reports its own number
  return number;
}

-setMinPrice: (float) min MaxPrice: (float) max 
                      minStartPrice: (float) minS 
                      maxStartPrice: (float) maxS { // absolute and
  float temp;                                       // starting range
  minPrice = min;                                   // see Vendor.h
  maxPrice = max;
  minStartPrice=minS;
  maxStartPrice=maxS;

  minOfferPrice=[uniformDblRand getDoubleWithMin: (double) minStartPrice
                                         withMax: (double) maxStartPrice];
  maxOfferPrice=[uniformDblRand getDoubleWithMin: (double) minStartPrice
                                         withMax: (double) maxStartPrice];

    if( minOfferPrice > maxOfferPrice){
                                       temp=maxOfferPrice;
                                       maxOfferPrice=minOfferPrice;
                                       minOfferPrice=temp;                        
                                       }
  return self;
}

-chooseRange {                                       // it selects the range
                                                     // of a specific
                                                     // offer

    if(memory < -1) {minOfferPrice -= [uniformDblRand 
                                       getDoubleWithMin: (double) 0
                                                withMax: (double) 4];
                     maxOfferPrice -= [uniformDblRand 
                                       getDoubleWithMin: (double) 0
                                                withMax: (double) 4];
                    }
    if(memory >  1) {minOfferPrice += [uniformDblRand 
                                       getDoubleWithMin: (double) 0
                                                withMax: (double) 4];
                     maxOfferPrice += [uniformDblRand 
                                       getDoubleWithMin: (double) 0
                                                withMax: (double) 4];
                    }
    if(minOfferPrice < minPrice) minOfferPrice = minPrice;
    if(maxOfferPrice > maxPrice) maxOfferPrice = maxPrice;
  // the following are rare but possible 
    if(minOfferPrice > maxPrice) minOfferPrice = maxPrice;
    if(maxOfferPrice < minPrice) maxOfferPrice = minPrice;

                                                     // and reports it
if (use_printf==2)
printf("Vendor number %2d, offer range %6.2f %6.2f\n",number,
                                 minOfferPrice,maxOfferPrice);
  return self;
}

- (float) makeAnOffer{     // price of a specific offer
                           // notice that the return is a float
  float p;

  p=[uniformDblRand getDoubleWithMin: (double) minOfferPrice
                            withMax: (double) maxOfferPrice];
  // uniformDblRand produces a float; it requires two doubles
  // as arguments

if (use_printf==2)
printf("I'm vendor number %2d and my offer price is %5.2f\n",number,p);

  return p;

}

-setMemory { // it clears the memory
  memory=0;
  return self;
}

-updateMemory: (int) yn { // yn=1 it operated; yn=0 it has not
  memory--;
  if(yn==1)memory += 2;
  return self;
}

-(float) reportMinPrice { // it reports the range Min. price ...
  return minOfferPrice;
}

-(float) reportMaxPrice { // and max price for the current offer
  return maxOfferPrice;
}

@end




